#include "beagle/GP.hpp"
#include "Pos.h"

#ifdef BEAGLE_HAVE_RTTI
#include <typeinfo>
#endif // BEAGLE_HAVE_RTTI

using namespace Beagle;

/////////////////////////////////////////////////////////////////////////////////////////////
// funkcija: POS
GP::Pos::Pos(std::string inName) :
  Beagle::GP::Primitive(1, inName)	// broj argumenata!!
{ }
std::string GP::Pos::getArgType(unsigned int inN) const
{
#ifdef BEAGLE_HAVE_RTTI
  Beagle_AssertM(inN < 1);
  return typeid(Double).name();
#else  // BEAGLE_HAVE_RTTI
  throw Beagle_UndefinedMethodInternalExceptionM("getArgType","GP::Pos");
  return "";
#endif // BEAGLE_HAVE_RTTI
}
std::string Beagle::GP::Pos::getReturnType() const
{
#ifdef BEAGLE_HAVE_RTTI
  return typeid(Double).name();
#else  // BEAGLE_HAVE_RTTI
  throw Beagle_UndefinedMethodInternalExceptionM("getReturnType","GP::Pos");
  return "";
#endif // BEAGLE_HAVE_RTTI
}
void GP::Pos::execute(GP::Datum& outResult, GP::Context& ioContext)
{ }

/////////////////////////////////////////////////////////////////////////////////////////////
// funkcija: SQR
GP::Sqr::Sqr(std::string inName) :
  Beagle::GP::Primitive(1, inName)	// broj argumenata!!
{ }
std::string GP::Sqr::getArgType(unsigned int inN) const
{
#ifdef BEAGLE_HAVE_RTTI
  Beagle_AssertM(inN < 1);
  return typeid(Double).name();
#else  // BEAGLE_HAVE_RTTI
  throw Beagle_UndefinedMethodInternalExceptionM("getArgType","GP::Sqr");
  return "";
#endif // BEAGLE_HAVE_RTTI
}
std::string Beagle::GP::Sqr::getReturnType() const
{
#ifdef BEAGLE_HAVE_RTTI
  return typeid(Double).name();
#else  // BEAGLE_HAVE_RTTI
  throw Beagle_UndefinedMethodInternalExceptionM("getReturnType","GP::Sqr");
  return "";
#endif // BEAGLE_HAVE_RTTI
}
void GP::Sqr::execute(GP::Datum& outResult, GP::Context& ioContext)
{ }

/////////////////////////////////////////////////////////////////////////////////////////////
// funkcija: IFGT
GP::IfGT::IfGT(std::string inName) :
  Beagle::GP::Primitive(4, inName)	// broj argumenata!!
{ }
std::string GP::IfGT::getArgType(unsigned int inN) const
{
#ifdef BEAGLE_HAVE_RTTI
  Beagle_AssertM(inN < 1);
  return typeid(Double).name();
#else  // BEAGLE_HAVE_RTTI
  throw Beagle_UndefinedMethodInternalExceptionM("getArgType","GP::IfGT");
  return "";
#endif // BEAGLE_HAVE_RTTI
}
std::string Beagle::GP::IfGT::getReturnType() const
{
#ifdef BEAGLE_HAVE_RTTI
  return typeid(Double).name();
#else  // BEAGLE_HAVE_RTTI
  throw Beagle_UndefinedMethodInternalExceptionM("getReturnType","GP::IfGT");
  return "";
#endif // BEAGLE_HAVE_RTTI
}
void GP::IfGT::execute(GP::Datum& outResult, GP::Context& ioContext)
{ }