#ifndef Beagle_GP_Pos_h
#define Beagle_GP_Pos_h

#include <string>
#include "beagle/config.hpp"
#include "beagle/macros.hpp"
#include "beagle/Object.hpp"
#include "beagle/AllocatorT.hpp"
#include "beagle/PointerT.hpp"
#include "beagle/ContainerT.hpp"
#include "beagle/WrapperT.hpp"
#include "beagle/Bool.hpp"
#include "beagle/GP/Primitive.hpp"
#include "beagle/GP/PrimitiveInline.hpp"
#include "beagle/GP/Context.hpp"
#include "beagle/GP/Datum.hpp"

namespace Beagle {
namespace GP {

/////////////////////////////////////////////////////////////////////////////////////////////
// funkcija: POS
class Pos : public Primitive {
public:
  //! GP::Pos allocator type.
  typedef AllocatorT<Pos,Primitive::Alloc>
          Alloc;
  //! GP::Pos handle type.
  typedef PointerT<Pos,Primitive::Handle>
          Handle;
  //! GP::Pos bag type.
  typedef ContainerT<Pos,Primitive::Bag>
          Bag;
  explicit Pos(std::string inName="POS");
  virtual ~Pos() { }
  virtual std::string getArgType(unsigned int inN) const;
  virtual std::string getReturnType() const;
  virtual void        execute(GP::Datum& outResult, GP::Context& ioContext);
};

/////////////////////////////////////////////////////////////////////////////////////////////
// funkcija: SQR
class Sqr : public Primitive {
public:
  //! GP::Sqr allocator type.
  typedef AllocatorT<Sqr,Primitive::Alloc>
          Alloc;
  //! GP::Sqr handle type.
  typedef PointerT<Sqr,Primitive::Handle>
          Handle;
  //! GP::Sqr bag type.
  typedef ContainerT<Sqr,Primitive::Bag>
          Bag;
  explicit Sqr(std::string inName="SQR");
  virtual ~Sqr() { }
  virtual std::string getArgType(unsigned int inN) const;
  virtual std::string getReturnType() const;
  virtual void        execute(GP::Datum& outResult, GP::Context& ioContext);
};

/////////////////////////////////////////////////////////////////////////////////////////////
// funkcija: IFGT
class IfGT : public Primitive {
public:
  //! GP::IfGT allocator type.
  typedef AllocatorT<IfGT,Primitive::Alloc>
          Alloc;
  //! GP::IfGT handle type.
  typedef PointerT<IfGT,Primitive::Handle>
          Handle;
  //! GP::IfGT bag type.
  typedef ContainerT<IfGT,Primitive::Bag>
          Bag;
  explicit IfGT(std::string inName="IFGT");
  virtual ~IfGT() { }
  virtual std::string getArgType(unsigned int inN) const;
  virtual std::string getReturnType() const;
  virtual void        execute(GP::Datum& outResult, GP::Context& ioContext);
};


}
}

#endif // Beagle_GP_Pos_h
